﻿import com.lo9ic.Node;
import com.lo9ic.Style;
import com.lo9ic.Drawable;

class com.lo9ic.Line implements Drawable {
	private var $startnode, $endnode:Node;
	private var $style:Style;
	private var $clip:MovieClip;

	function Line(a:Node, b:Node) {
		$startnode = a ? a : new Node();
		$endnode = b ? b : new Node();
		$style = new Style();
	}

	public function set startnode(a:Node):Void {
		$startnode = a;
	}

	public function set endnode(a:Node):Void {
		$endnode = a;
	}

	public function get startnode():Node {
		return $startnode;
	}

	public function get endnode():Node {
		return $endnode;	
	}
	
	public function set style(a:Style):Void {
		$style = a ? a:$style;
	}
	
	public function get style():Style {
		return $style;
	}

	public function set clip(a:MovieClip):Void {
		$clip = a;
	}

	public function draw():Void {
		$clip.clear();
		$clip.moveTo($startnode.x, $startnode.y);
		$clip.lineStyle($style.lineweight, $style.linecolor, $style.linealpha);
		$clip.lineTo($endnode.x, $endnode.y);
		$clip.swapDepths(10000+($endnode.z+$startnode.z)/2);
	}
}