﻿import com.lo9ic.Style;
import com.lo9ic.Quaternion;
import com.lo9ic.Node;
import com.lo9ic.Drawable;

class com.lo9ic.Scene implements Drawable {
	private var $f:Number;
	private var $nodes:Array;
	private var $objects:Array;
	private var $quaternion:Quaternion;
	private var $clip:MovieClip;
	private var $i:Number;
	function Scene() {
		$f = 300;
		$nodes = new Array();
		$objects = new Array();
		$quaternion = new Quaternion();
	}
	
	public function get f():Number {
		return $f;
	}
	
	public function set f(a:Number):Void {
		$f = a;
	}	
	
	public function set quaternion(a:Quaternion):Void {
		$quaternion = a;
	}
	
	public function get quaternion():Quaternion {
		return $quaternion;
	}
	
	public function set clip(a:MovieClip):Void {
		$clip = a;
	}
	
	public function get clip():MovieClip {
		return $clip;
	}
	
	public function addNode(a:Node):Void {
		$nodes.push(a);
	}
	
	public function addObject(a:Drawable):Void {
		$objects.push(a);
	}
	
	public function draw():Void {
		$i = 0;
		while($i<$nodes.length) {
			$nodes[$i].rotate($quaternion);
			$nodes[$i].project($f);
			$i++;
		}
		$i = 0;
		while($i<$objects.length) {
			$objects[$i].draw();
			$i++;
		}	
	}
}