﻿import com.lo9ic.Node;
import com.lo9ic.Style;
import com.lo9ic.Line;
import com.lo9ic.Drawable;

class com.lo9ic.Curve extends Line implements Drawable {
	private var $controlnode : Node;
	
	function Curve(a:Node, b:Node, c:Node) {
		$startnode = a ? a : new Node();
		$endnode = b ? b : new Node();
		$controlnode = c ? c : new Node();
	}
	
	public function set controlnode(a:Node):Void {
		$controlnode = a;
	}
	
	public function get controlnode():Node {
		return $controlnode;
	}

	public function draw():Void {
		$clip.clear();
		$clip.moveTo($startnode.x, $startnode.y);
		$clip.lineStyle($style.lineweight, $style.linecolor, $style.linealpha);
		$clip.curveTo($controlnode.x, $controlnode.y, $endnode.x, $endnode.y);
		$clip.swapDepths(10000+($endnode.z+$startnode.z+$controlnode.z)/3);
	}
}